/*This is the class Fonction of syntaxe-V3.0*/
/*la procedure lirident a ete modifiee pour autoriser les chiffres dans les noms de fonction*/

/*syntaxe is a java package for syntax analysis, evaluation and
management of mathematical functionnal expressions.
Copyright (C) 2008 Robert Rolland  */
/*robert.rolland@acrypta.fr*/

/*Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence Publique Générale GNU publiée par la Free Software Foundation (version 2 ou bien toute autre version ultérieure choisie par vous).

Ce programme est distribué car potentiellement utile, mais SANS AUCUNE GARANTIE, 
ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation 
dans un but spécifique. Reportez-vous à la Licence Publique Générale GNU pour plus de détails.

Vous devez avoir reçu une copie de la Licence Publique Générale GNU en même temps 
que ce programme ; si ce n'est pas le cas, écrivez à la 
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, États-Unis.*/

package rr.modulog.syntaxe;
import java.lang.Math;
public class Fonction{
/******************************************************************
*************** VARIABLES D'INSTANCE ******************************
******************************************************************/

  private NomDeFonction        nom;
  private byte                 nbvar;
  private ExpressionDeFonction expression;
  private ArbreDeFonction      arbre;
  private short                numero;  
  private short                enusage;

/******************************************************************
*************** VARIABLES DE CLASSE (GLOBALES) ********************
******************************************************************/

  final static short           TAILLE_TABLE_FONCT = 100;
  final static short           TAILLE_TABLE_CONST = 2;
  final static short           LONG_CONST         = 2;

  private static String[]      tableconst = new String[TAILLE_TABLE_CONST];

  private static Fonction[]    tablefonct = new Fonction[TAILLE_TABLE_FONCT];
  private static Allocation    freels     = null;
  private static Allocation    occupls    = null;

/******************************************************************
*************** VARIABLES DE CLASSE (LOCALES) *********************
******************************************************************/

  final static short       TAILLE_PILE        = 50;
  
  private static ArbreDeFonction[] pile       = new ArbreDeFonction[TAILLE_PILE];
  private static short             SP         = (short) -1;
  private static short             Ind        = (short) -1;
  private static int[]             Var_List   = new int[26];
  private static int               Fct_Nb_Var = 0;
  private static int               Fct_Numero = 0;

/******************************************************************
*************** INITIALISATION ************************************
******************************************************************/  
  static{
    tableconst[0]="E";
    tableconst[1]="PI";
    freels=null;
    for (short i=TAILLE_TABLE_FONCT-1; i>=0; i--){
      Allocation P1=new Allocation();
      P1.place=i;
      P1.suivant=freels;
      freels=P1;
    }   
    insere_nouvelle_fonction_1("ABS");
    insere_nouvelle_fonction_1("ACH");
    insere_nouvelle_fonction_1("ACOS");
    insere_nouvelle_fonction_1("ASH");
    insere_nouvelle_fonction_1("ASIN");
    insere_nouvelle_fonction_1("ATAN");
    insere_nouvelle_fonction_1("ATH");
    insere_nouvelle_fonction_1("CH");
    insere_nouvelle_fonction_1("COS");
    insere_nouvelle_fonction_1("EXP");
    insere_nouvelle_fonction_1("FRAC");
    insere_nouvelle_fonction_1("INT");
    insere_nouvelle_fonction_1("LOG");
    insere_nouvelle_fonction_1("LN");
    insere_nouvelle_fonction_1("SH");
    insere_nouvelle_fonction_1("SIN");
    insere_nouvelle_fonction_1("SQR");
    insere_nouvelle_fonction_1("SQRT");
    insere_nouvelle_fonction_1("TG");
    insere_nouvelle_fonction_1("TH");
    insere_nouvelle_fonction_1("CONJ");
    insere_nouvelle_fonction_1("RE");
    insere_nouvelle_fonction_1("IM");
    insere_nouvelle_fonction_1("ARG");
    insere_nouvelle_fonction_2("MAX");
    insere_nouvelle_fonction_2("MIN");
  } 
  
/******************************************************************
*************** PROCEDURES LOCALES ********************************
******************************************************************/  

  private static void insere_nouvelle_fonction_1(String S){
    short i=freels.place;
    freels=freels.suivant;
    Allocation Q=new Allocation();
    Q.place=i;
    Q.suivant=null;
    if (occupls==null){
      occupls=Q;
    }
    else{
      Allocation Q1=occupls;
      while (Q1.suivant!=null){
        Q1=Q1.suivant;    
      }
      Q1.suivant=Q;
    }
    ArbreDeFonction variable1= new ArbreDeFonction((byte) 2,'+',
      (short) 0,(short) 1,0.0,',',(short) 0,null,null);
     
    tablefonct[i]=new Fonction();
    tablefonct[i].nom=new NomDeFonction(S);
    tablefonct[i].nbvar=(byte) 1;
    tablefonct[i].expression=new ExpressionDeFonction(S+"(X)");
    tablefonct[i].arbre=new ArbreDeFonction((byte) 1,'+',(short) i,
       (short) 0,0.0,',',(short) 0,variable1,null);
    tablefonct[i].numero=i;  
  }

/*****************************************************************/

  private static void insere_nouvelle_fonction_2(String S){
    short i=freels.place;
    freels=freels.suivant;
    Allocation Q=new Allocation();
    Q.place=i;
    Q.suivant=null;
    if (occupls==null){
      occupls=Q;
    }
    else{
      Allocation Q1=occupls;
      while (Q1.suivant!=null){
        Q1=Q1.suivant;    
      }
      Q1.suivant=Q;
    }
    ArbreDeFonction variable1= new ArbreDeFonction((byte) 2,'+',
      (short) 0,(short) 1,0.0,',',(short) 0,null,null);
    ArbreDeFonction variable2= new ArbreDeFonction((byte) 2,'+',
      (short) 0,(short) 2,0.0,',',(short) 0,null,null);
    ArbreDeFonction var1var2=  new ArbreDeFonction((byte) 5,'+', 
      (short) 0,(short) 0,0.0,',',(short) 0,variable1,variable2);
    tablefonct[i]=new Fonction();
    tablefonct[i].nom=new NomDeFonction(S);
    tablefonct[i].nbvar=(byte) 2;
    tablefonct[i].expression=new ExpressionDeFonction(S+"(X,Y)");
    tablefonct[i].arbre=new ArbreDeFonction((byte) 1,'+',(short) i,
       (short) 0,0.0,',',(short) 0,var1var2,null);
    tablefonct[i].numero=i;  
  }

/*****************************************************************/

  private static void incremente(){
    SP=(short) (SP+1);
  }

/*****************************************************************/
  
  private static void decremente(){
    SP=(short) (SP-1);
  }

/*****************************************************************/
 
  private static void incrementeI(){
    Ind=(short) (Ind+1);
  }

/*****************************************************************/
  
  private static void decrementeI(){
    Ind=(short) (Ind-1);
  }

/*****************************************************************/  
 
  private static ArbreDeFonction depile(){
    if (pile[SP]==null) {
      ArbreDeFonction P= new ArbreDeFonction();
      P=null;
      decremente();
      return P;
    }
    else {  
      ArbreDeFonction P=
        new ArbreDeFonction(pile[SP].opertype, pile[SP].signe, pile[SP].fonctcode, pile[SP].varcode,
        pile[SP].constante, pile[SP].separateur, pile[SP].constform, pile[SP].oper1, pile[SP].oper2);
      pile[SP]=null;
      decremente();
      return P;
    }  
    
  }
  
/*****************************************************************/
    
  private static void empile(ArbreDeFonction P){
    incremente();
    if (P==null) {
      pile[SP]=new ArbreDeFonction();
      pile[SP]=null;
    }
    else {  
      pile[SP]=new ArbreDeFonction(P.opertype, P.signe, P.fonctcode, P.varcode,
        P.constante, P.separateur, P.constform, P.oper1, P.oper2);
    }	
  }		  

/*****************************************************************/

  private static void setvarlist(char C,int i){
    Var_List[(int) C -65]=i;
  }

/*****************************************************************/
  
  private static int getvarlist(char C){
    return Var_List[(int) C -65];
  }

/*****************************************************************/

  private static void Expressionfonct1(String S)
  throws FonctionException{
    if (S.charAt(Ind +1)!=')'){ 
      NonV1(S);
    }
    else {
      incrementeI();
      Fct_Nb_Var=0;   
    }
  }

/*****************************************************************/
  
  private static void NonV1(String S)
  throws FonctionException{
    int vanum=0;
    if ((S.charAt(Ind+1) < 'A') || (S.charAt(Ind+1) > 'Z')) {
      throw new FonctionException(11);
    }  
    else {
      incrementeI();
      char C=S.charAt(Ind);
      vanum=vanum+1;
      if (getvarlist(C)!=0){
        throw new FonctionException(10); 
      }
      else{
        setvarlist(C,vanum);
        while (S.charAt(Ind+1)==','){
          incrementeI();
	  if ((S.charAt(Ind+1) < 'A') || (S.charAt(Ind+1) > 'Z')) {
            throw new FonctionException(11);
          }
	  else{
	    incrementeI();
	    C=S.charAt(Ind);
	    vanum=vanum+1;
	    if (getvarlist(C)!=0){
	      throw new FonctionException(10);
	    }
	    else{
	      setvarlist(C,vanum);
	      
	    }   
	  }
	}
	Fct_Nb_Var=vanum;
	if (S.charAt(Ind +1)!=')'){
	  throw new FonctionException(2);
	}
	else{
	  incrementeI();
	}
      }     
    } 
  }

/*****************************************************************/
  
  private static void Exp1(String S)
  throws FonctionException{
    Expression(S);
    incrementeI();
    if (S.charAt(Ind)!='$'){
      throw new FonctionException(4);
    }  
  }  

/*****************************************************************/

  private static void Expression(String S)
  throws FonctionException{
    if ((S.charAt(Ind+1) == '+') || (S.charAt(Ind+1) == '-')) {
      incrementeI();
      char C=S.charAt(Ind);
      Term(S);
      ArbreDeFonction T=new ArbreDeFonction();
      T=depile();
      ArbreDeFonction P=new ArbreDeFonction((byte) 4, C, (short) 0, (short) 0, 0.0, ',', 
                         (short) 0, T, null); 
      empile(P);
      ST(S);
    }
    else{
      Term(S);
      ST(S); 
    }    
  }
/*****************************************************************/

  private static void Term(String S)
  throws FonctionException{
    Facteur(S);
    SF(S);  
  }

/*****************************************************************/

  private static void ST(String S)
  throws FonctionException{
    if ((S.charAt(Ind+1) == '+') || (S.charAt(Ind+1) == '-')) {
      incrementeI();
      char C=S.charAt(Ind);
      Term(S);
      ArbreDeFonction T1=new ArbreDeFonction();
      ArbreDeFonction T2=new ArbreDeFonction();
      T2=depile();
      T1=depile(); 
      ArbreDeFonction P=new ArbreDeFonction((byte) 0, C, (short) 0, (short) 0, 0.0, ',', 
                         (short) 0, T1,T2); 
      empile(P);
      ST(S);
    }    
  }

/*****************************************************************/ 

  private static void Facteur(String S)
  throws FonctionException{
    Fact(S);
    Sfact(S);
  }


/*****************************************************************/ 

  private static void SF(String S)
  throws FonctionException{
    if ((S.charAt(Ind+1) == '*') || (S.charAt(Ind+1) == '/')||
        (S.charAt(Ind+1) == '%')) {
      incrementeI();
      char C=S.charAt(Ind); 
      Facteur(S);
      ArbreDeFonction T1=new ArbreDeFonction();
      ArbreDeFonction T2=new ArbreDeFonction();
      T2=depile();
      T1=depile(); 
      ArbreDeFonction P=new ArbreDeFonction((byte) 0,C,(short) 0,(short) 0,
					     0.0,',',(short) 0,T1,T2); 
      empile(P);
      SF(S);
    } 
  }

/*****************************************************************/ 

  private static void Fact(String S)
  throws FonctionException{
    incrementeI();
    if ((S.charAt(Ind) >= 'A') && (S.charAt(Ind) <= 'Z')) {
      PtrInt N=new PtrInt(Ind);
      String U=lireident(S,N);
      Ind=(short) N.entier;
      PtrInt nmero=new PtrInt(0);
      boolean Y=cherchecst(U,nmero);
      if (Y){
        ArbreDeFonction P=new ArbreDeFonction((byte) 6, '+', (short) 0, (short) 0, 0.0, ',', 
                         (short) nmero.entier, null,null); 
        empile(P);	                    
      } 
      else{
        NomDeFonction Uf =new NomDeFonction(U);
	PtrInt Nmro = new PtrInt(0);
	PtrInt NbV = new PtrInt(0);
        Y=cherchefct(Uf,Nmro,NbV);
	if (Y){
	  F(S,NbV,Nmro);
	  
	} 
	else{
	  V(U); 
	}
      } 
    }
    else{
      if ((S.charAt(Ind) >= '0') && (S.charAt(Ind) <= '9')) { 
        PtrInt N=new PtrInt(Ind);
	double Nombre=lirenombre(S,N);
	Ind=(short) N.entier;
	ArbreDeFonction P=new ArbreDeFonction((byte) 3, '+', (short) 0, (short) 0, Nombre, ',', 
                                              (short) 0, null,null); 
	empile(P);		 
      }
      else{
	E(S);
      }
    }
  }

/*****************************************************************/ 

  private static void Sfact(String S)
  throws FonctionException{
    if (S.charAt(Ind+1) == '^'){
      incrementeI();
      char C=S.charAt(Ind); 
      Facteur(S);
      ArbreDeFonction T1=new ArbreDeFonction();
      ArbreDeFonction T2=new ArbreDeFonction();
      T2=depile();
      T1=depile(); 
      ArbreDeFonction P=new ArbreDeFonction((byte) 0,C,(short) 0,(short) 0,
					     0.0,',',(short) 0,T1,T2); 
      empile(P);
    }
  }

/*****************************************************************/ 

  private static void F(String S,PtrInt NbV, PtrInt Nmro)
  throws FonctionException{
    int NRo=Nmro.entier;
    incrementeI();
    if (S.charAt(Ind) != '('){
      throw new FonctionException(1); 
    }
    else{
      ExpressFonct(S,NbV,Nmro);
      ArbreDeFonction T=new ArbreDeFonction();
      T=depile();
      ArbreDeFonction P=new ArbreDeFonction((byte) 1,'+',(short) NRo,(short) 0,
					     0.0,',',(short) 0,T,null);
      empile(P);
      incrementeI();
      if (S.charAt(Ind) != ')'){
        throw new FonctionException(2); 
      }
    } 
  }

/*****************************************************************/ 

  private static void ExpressFonct(String S, PtrInt NbV, PtrInt Nmro)
  throws FonctionException{
    int NVa=NbV.entier;
    if (S.charAt(Ind+1) != ')'){
      NonV(S,NbV,Nmro);      
    }
    else{
      if (NVa!=0){
        throw new FonctionException(7);
      }
      else {
	ArbreDeFonction P=new ArbreDeFonction();
	P=null;
	empile(P);
      }  
    }
  }
  
/*****************************************************************/ 

  private static void V(String U)
  throws FonctionException{
    if (U.length()>1){
      throw new FonctionException(3); 
    }
    else{
      int VN=getvarlist(U.charAt(0));
      if (VN <=0){
        throw new FonctionException(11); 
      }
      else{
        ArbreDeFonction P=new ArbreDeFonction((byte) 2,'+',(short) 0,(short) VN,
					     0.0,',',(short) 0,null,null);
        empile(P); 
      }
    } 
  }

/*****************************************************************/ 

  private static void E(String S)
  throws FonctionException{
    if (S.charAt(Ind) == '('){
      Expression(S);
      incrementeI();
      if (S.charAt(Ind) != ')'){
        throw new FonctionException(2);  
      }
    }
    else{
      throw new FonctionException(1); 
    }  
  }
               
/*****************************************************************/
 
  private static void NonV(String S, PtrInt NbV, PtrInt Nmro)
  throws FonctionException{
    ArbreDeFonction T=new ArbreDeFonction();
    ArbreDeFonction P=null;   
    int No=Nmro.entier;
    int Compteur=1;
    int Nva=NbV.entier;
    Expression(S);
    while (S.charAt(Ind+1)==','){
      incrementeI();
      Compteur=Compteur+1;
      Expression(S);
    } 
    if (Compteur != Nva){
      throw new FonctionException(7); 
    }
    else{
      T=depile();
      P=T;
      for (int i=2;i<=Nva;i++){        
        T=depile();
	ArbreDeFonction P1= new ArbreDeFonction((byte) 5,'+',(short) 0, (short)0,
	  0.0, ',',(short) 0, T,P);
	P=P1;	 
      }
      empile(P);
    }
  } 

/*****************************************************************/
                    
  private static String preparation(String S) 
  throws FonctionException {
    int l=S.length();    
    char[] T=S.toCharArray();
    String S1="";
    for (int i=0; i <=l-1;i++) {
      if (T[i]!=' '){
        S1=S1+T[i];
      }
    }
    String S2=S1.toUpperCase();
    if (S2.length() > 0) return S2;
    else throw new FonctionException(5);     
  }

/*****************************************************************/

  private static double lirenombre(String S,PtrInt N)
    throws FonctionException
  {
    Double r = new Double(0.0);
    int i = N.entier;
    int j = i;
    while ((S.charAt(j+1) >='0') && (S.charAt(j+1) <='9')) 
      j=j+1;
    if (S.charAt(j+1) =='.')
      {
        j=j+1;
        if ((S.charAt(j+1) <'0') || (S.charAt(j+1) >'9'))
          {
            throw new FonctionException(6);
            
          }
        while ((S.charAt(j+1) >='0') && (S.charAt(j+1) <='9')) 
          j=j+1;
        if (S.charAt(j+1)=='E')
          {
            j=j+1;
            if (((S.charAt(j+1) <'0') || (S.charAt(j+1) >'9')) 
                 && ((S.charAt(j+1) != '+') && (S.charAt(j+1) != '-')))
              {
                throw new FonctionException(6);
                
              }
            if ((S.charAt(j+1) == '+') || (S.charAt(j+1) == '-'))
              {
                j=j+1;
                if ((S.charAt(j+1) <'0') || (S.charAt(j+1) >'9'))
                  {
                    throw new FonctionException(6);
                    
                  }
                while ((S.charAt(j+1) >='0') && (S.charAt(j+1) <='9')) 
                  j=j+1;
              }
             else
              { 
              while ((S.charAt(j+1) >='0') && (S.charAt(j+1) <='9')) 
                  j=j+1;
              }
           }
      }    
    else if (S.charAt(j+1) == 'E')
           {
            j=j+1;
            if (((S.charAt(j+1) <'0') || (S.charAt(j+1) >'9')) 
                 && ((S.charAt(j+1) != '+') && (S.charAt(j+1) != '-')))
              {
                throw new FonctionException(6);
                
              }
            if ((S.charAt(j+1) == '+') || (S.charAt(j+1) == '-'))
              {
                j=j+1;
                if ((S.charAt(j+1) <'0') || (S.charAt(j+1) >'9'))
                  {
                    throw new FonctionException(6);
                    
                  }
                while ((S.charAt(j+1) >='0') && (S.charAt(j+1) <='9')) 
                  j=j+1;
              }
             else
              { 
              while ((S.charAt(j+1) >='0') && (S.charAt(j+1) <='9')) 
                  j=j+1;
              }
           }
    j=j+1;
    
    String T= S.substring(i,j);
    N.entier=j-1;
    try{
      r=Double.valueOf(T);
    }
    catch(NumberFormatException e){
    }
        
    return r.doubleValue();
  }

/*****************************************************************/

  private static String lireident(String S,PtrInt N){
    int i = N.entier;
    int j = i;
    while (((S.charAt(j+1) >= 'A') && (S.charAt(j+1) <= 'Z'))||
           ((S.charAt(j+1) >= '0') && (S.charAt(j+1) <= '9')))
    { 
      j=j+1;
    }
    j=j+1;
    
    String T = S.substring(i,j);
    N.entier=j-1;
    return T;
  }

/*****************************************************************/

  private static boolean cherchefct(NomDeFonction S, PtrInt nmero, PtrInt nbv){
    boolean Y=false;
    Allocation Q = occupls;
    while ((Q != null) && (!(S.nom.equals(tablefonct[Q.place].nom.nom)))){
      Q=Q.suivant;
    }
      
      
    if ((Q != null) && (S.nom.equals(tablefonct[Q.place].nom.nom))){ 
      Y=true;
      nmero.entier=Q.place;
      nbv.entier=tablefonct[Q.place].nbvar;
    }
    return Y;
  }

/*****************************************************************/
    
  private static boolean cherchecst(String S, PtrInt nmero){
    boolean Y = false;
    int I = 0;
    if (S.equals(tableconst[I])){
      Y=true;
      nmero.entier=I;
    }
    else {
      while ((!(S.equals(tableconst[I]))) && (I<TAILLE_TABLE_CONST-1)){
        I=I+1;
        if (S.equals(tableconst[I])){
          Y=true;
          nmero.entier=I;
        }
      }	
    }
    return Y;
  } 
   
/*****************************************************************/

  private static void scruteplus(ArbreDeFonction b){
    if (b!=null) {
    
      switch(b.opertype){
        case 0:
          scruteplus(b.oper1);
	  scruteplus(b.oper2);          
          break;
        case 1:
          tablefonct[b.fonctcode].enusage++;
	  scruteplus(b.oper1);
          break;
        case 2:
          break;
        case 3: 
          break;
        case 4:
          scruteplus(b.oper1);
          break;
        case 5:
          scruteplus(b.oper1);
	  scruteplus(b.oper2); 
          break;
        case 6:           
          break;
      }      
    } 
  } 
    
/*****************************************************************/

  private static void scrutemoins(ArbreDeFonction b){
    if (b!=null) {
    
      switch(b.opertype){
        case 0:
          scrutemoins(b.oper1);
	  scrutemoins(b.oper2);          
          break;
        case 1:
          tablefonct[b.fonctcode].enusage--;
	  scrutemoins(b.oper1);
          break;
        case 2:
          break;
        case 3: 
          break;
        case 4:
          scrutemoins(b.oper1);
          break;
        case 5:
          scrutemoins(b.oper1);
	  scrutemoins(b.oper2); 
          break;
        case 6:           
          break;
      }      
    } 
  } 

/*****************************************************************/

  private static ArbreDeFonction copieArbre(ArbreDeFonction b){
    ArbreDeFonction T=new ArbreDeFonction();
    if (b==null){
      T=null;     
    }
    else {              
      switch(b.opertype){
        case 0:
	  ArbreDeFonction F01=copieArbre(b.oper1);
	  ArbreDeFonction F02=copieArbre(b.oper2);
          T=new ArbreDeFonction(b.opertype,b.signe,
	    (short) 0, (short) 0, (double) 0.0, ',', (short) 0, F01,F02);
	  break;            
        case 1:
          ArbreDeFonction F11=copieArbre(b.oper1);
	  T=new ArbreDeFonction(b.opertype,'+',
	    b.fonctcode, (short) 0, (double) 0.0, ',', (short) 0, F11,null);
	  break;            
        case 2:
          T=new ArbreDeFonction(b.opertype,'+',
	    (short) 0, b.varcode, (double) 0.0, ',', (short) 0, null,null);
	  break;            
        case 3: 
	  T=new ArbreDeFonction(b.opertype,'+',
	    (short) 0, (short) 0, b.constante, ',', (short) 0, null,null);
	  break;                      
        case 4:
          ArbreDeFonction F41=copieArbre(b.oper1);
	  T=new ArbreDeFonction(b.opertype,b.signe,
	    (short) 0, (short) 0, (double) 0.0, ',', (short) 0, F41,null);
	  break;
          
        case 5:
          ArbreDeFonction F51=copieArbre(b.oper1);
	  ArbreDeFonction F52=copieArbre(b.oper2);
          T=new ArbreDeFonction(b.opertype,'+',
	    (short) 0, (short) 0, (double) 0.0, b.separateur, 
	    (short) 0, F51,F52);
	  break;	  
        case 6: 
          T=new ArbreDeFonction(b.opertype,'+',
	    (short) 0, (short) 0, (double) 0.0, ',', b.constform, null,null);
	  break;           
      }        
    }
    return T;   
  }
    
/******************************************************************
*************** METHODES DE LA CLASSE *****************************
******************************************************************/  	   

  public Fonction(){
  }

/*****************************************************************/
  
  public Fonction(String S)
  throws FonctionException
  { 
    this();
    
    PtrInt nmero=new PtrInt(0); 
    PtrInt nbv=new PtrInt(0);
    
    SP=-1;
    Ind=-1;
    Fct_Nb_Var=0;
    Fct_Numero=-1;
    
    for (char C='A'; C <= 'Z'; C++){
      setvarlist(C,0);
    }  
    String S1=preparation(S);
    S=S1+"$";
    
    ExpressionDeFonction Ex=new ExpressionDeFonction(S1);
    expression=Ex; 
    
    if ((S.charAt(Ind+1) < 'A') || (S.charAt(Ind+1) > 'Z')) {
      throw new FonctionException(12);
    }  
    else {
      Ind=(short) (Ind+1);
      PtrInt n= new PtrInt(Ind);      
      String S2=lireident(S,n);
      Ind=(short) n.entier;
      NomDeFonction U= new NomDeFonction(S2);
      boolean Y= cherchefct(U,nmero,nbv);
      if (Y){
        throw new FonctionException(8);
      }
      else{
        nom=U;
	incrementeI();
	if (S.charAt(Ind)!='('){
	  throw new FonctionException(1);
	}
	else{
	  Expressionfonct1(S);
	  nbvar=(byte) Fct_Nb_Var;
	  if (S.charAt(Ind +1)!='='){
	    throw new FonctionException(9);
	  }
	  else{
	    incrementeI();
	    Exp1(S);
	    
	    arbre=pile[0];
	    if (freels==null){
	      throw new FonctionException(13);
	    }
	    else {   
	      numero=freels.place;
	      
	      freels=freels.suivant;
	      Allocation Q2= new Allocation();
	      Q2.place=numero;
	      Q2.suivant=null;
	      Allocation Q1=occupls;
              while (Q1.suivant!=null){
                Q1=Q1.suivant;    
              }
              Q1.suivant=Q2;
	      
	      enusage=0;
	      tablefonct[numero]= new Fonction();
	      tablefonct[numero].nom=nom;
	      tablefonct[numero].nbvar=nbvar;
	      tablefonct[numero].expression=expression;
	      tablefonct[numero].arbre=arbre;
	      tablefonct[numero].numero=numero;
	      tablefonct[numero].enusage=enusage;
	      scruteplus(arbre);
	    }
	  }
	}	
      }
    }
  }

/*****************************************************************/   

  public NomDeFonction getNomDeFonction() 
  
  {
    NomDeFonction nf=new NomDeFonction(nom.nom);
    return nf;
  }

/*****************************************************************/
  
  public ArbreDeFonction getArbreDeFonction()
  
  {   
      ArbreDeFonction T=new ArbreDeFonction();
      T=copieArbre(arbre);
      return T;
  }

/*****************************************************************/
  
  public ExpressionDeFonction getExpressionDeFonction()
  
  {  
    ExpressionDeFonction ef=new ExpressionDeFonction(expression.expression);
    return ef;
  }

/*****************************************************************/  

  public short getNumeroDeFonction()
  
  {
    return numero;
  }

/*****************************************************************/
  
  public byte getNombreDeVariables()
  
  {
    return nbvar;
  }  

/*****************************************************************/
 
  public short getEnusage()
  
  {
    enusage = tablefonct[getNumeroDeFonction()].enusage;
    return enusage;
  }  

/*****************************************************************/ 
  
  public static Fonction getFonction(short i)
  
  {
    return tablefonct[i];    
  }
  
/*****************************************************************/   

  public void libereFonction()
    throws FonctionException {
      if (tablefonct[getNumeroDeFonction()].enusage>0){
        throw new FonctionException(14);
      }
      else { 
        scrutemoins(arbre);       
        Allocation Q1=occupls;
        while (Q1.suivant.place!=numero){
                Q1=Q1.suivant; 
	}
	Allocation Q2=new Allocation();
	Q2.place=numero;
	Q2.suivant=freels;
	freels=Q2;
	Q1.suivant=Q1.suivant.suivant;
		 
      }
    
  }
  
/*****************************************************************/

  private double EvalArbre(ArbreDeFonction T,double[] v)
    throws Exception {
      double x=0,y=0,result=0;
      switch(T.opertype){
        case 0:
          x=EvalArbre(T.oper1,v);
	  y=EvalArbre(T.oper2,v);
	  switch(T.signe){
	  case '+':
	    result=x+y;
	    break;
	  case '-':
	    result=x-y;
	    break;
	  case '*':
	    result=x*y;
	    break;
	  case '/':
	    result=x/y;
	    break;
	  case '^':
	    result=Math.pow(x,y);
	    break;
	  case '%':
	    result=Math.IEEEremainder(x,y);
	    break;        
	  }
          break;
        case 1:
	  short n=T.fonctcode; 
          if (n<=25)
	    {
	      switch(n){ 
	      case 0:
	        x=EvalArbre(T.oper1,v);
	        result=Math.abs(x);
		break;
	      case 1:
	        x=EvalArbre(T.oper1,v);
	        result=Math.log(x+Math.sqrt(x*x-1));
		break;
	      case 2:
	        x=EvalArbre(T.oper1,v);
	        result=Math.acos(x);
		break;
	      case 3:
	        x=EvalArbre(T.oper1,v);
	        result=Math.log(x+Math.sqrt(x*x+1));
		break;
	      case 4:
	        x=EvalArbre(T.oper1,v);
	        result=Math.asin(x);
		break;
	      case 5:
	        x=EvalArbre(T.oper1,v);
	        result=Math.atan(x);
		break;
	      case 6:
	        x=EvalArbre(T.oper1,v);
	        result=(1/2)*Math.log((1+x)/(1-x)); 
		break;
	      case 7:
	        x=EvalArbre(T.oper1,v);
	        result=(1/2)*(Math.exp(x)+Math.exp(-x));
		break;
	      case 8:
	        x=EvalArbre(T.oper1,v);
	        result=Math.cos(x);
		break;
	      case 9:
	        x=EvalArbre(T.oper1,v);
	        result=Math.exp(x);
		break;
	      case 10:
	        x=EvalArbre(T.oper1,v);
	        result=x-Math.floor(x);
		break;
	      case 11:
	        x=EvalArbre(T.oper1,v);
	        result=Math.rint(x);
		break;
	      case 12:
	        x=EvalArbre(T.oper1,v);
	        result=Math.log(x)/Math.log(10.0);
		break;
	      case 13:
	        x=EvalArbre(T.oper1,v);
	        result=Math.log(x);
		break;
	      case 14:
	        x=EvalArbre(T.oper1,v);
	        result=(1/2)*(Math.exp(x)-Math.exp(-x));
		break;
	      case 15:
	        x=EvalArbre(T.oper1,v);
	        result=Math.sin(x);
		break;
	      case 16:
	        x=EvalArbre(T.oper1,v);
	        result=x*x;
		break;
	      case 17:
	        x=EvalArbre(T.oper1,v);
	        result=Math.sqrt(x);
		break;
	      case 18:
	        x=EvalArbre(T.oper1,v);
	        result=Math.tan(x);
		break;
	      case 19:
	        x=EvalArbre(T.oper1,v);
	        result=(Math.exp(x)-Math.exp(-x))/(Math.exp(x)+Math.exp(-x));
		break;
	      case 20:
	        x=EvalArbre(T.oper1,v);
	        result=x;
		break;
	      case 21:
	        x=EvalArbre(T.oper1,v);
	        result=x;
		break;
	      case 22:
	        x=EvalArbre(T.oper1,v);
	        result=0;
		break;
	      case 23:
	        x=EvalArbre(T.oper1,v);
	        result=0;
		break;
	      case 24:
	        x=EvalArbre(T.oper1.oper1,v);
		y=EvalArbre(T.oper1.oper2,v);
	        result=Math.max(x,y);
		break;
	      case 25:
	        x=EvalArbre(T.oper1.oper1,v);
		y=EvalArbre(T.oper1.oper2,v);
	        result=Math.min(x,y);
		break;
	      }
	      	
	    }
	  else
	    {
	      Fonction g=getFonction(n);
	      int k=g.getNombreDeVariables();
	      double[] tabval=new double[k];
	      if (k<2) 
	        {
		  tabval[0]=EvalArbre(T.oper1,v);
		  result=g.EvalFonct(tabval); 
		}
	      else
	        {
		  ArbreDeFonction Taux=T.oper1;
		  for (int j =0; j <=k-2;j++)
		    {
		      tabval[j]=EvalArbre(Taux.oper1,v);
		      Taux=Taux.oper2; 
		    }
		  tabval[k-1]=EvalArbre(Taux,v);
		  result=g.EvalFonct(tabval);
		}	
	    } 
          break;
        case 2:
          result=v[T.varcode-1]; 
          break;
        case 3: 
          result=T.constante;
          break;
        case 4:
          x=EvalArbre(T.oper1,v);
	  switch(T.signe){
	  case '+':
	    result=x;
	    break;
	  case '-':
	    result=-x;
	    break;
	  }  
          break;
        case 5:          
          break;
        case 6: 
          if (T.constform==0) result=Math.E;
	  else result=Math.PI;
          break;
      }  
      return result;     
    }
      
/*******************************************************************/ 

  public double EvalFonct(double[] v) 
    throws Exception {
    
      ArbreDeFonction T=this.getArbreDeFonction();
      double result=EvalArbre(T,v);
      return result;
    }

/*******************************************************************/ 

  public double EvalFonct(double x) 
    throws Exception {
      
      double[] v=new double[1];
      v[0]=x;
      ArbreDeFonction T=this.getArbreDeFonction();
      double result=EvalArbre(T,v);
      return result;
    }

/*******************************************************************/ 


  public double EvalFonct(double x,double y) 
    throws Exception {
      
      double[] v=new double[2];
      v[0]=x;v[1]=y;
      ArbreDeFonction T=this.getArbreDeFonction();
      double result=EvalArbre(T,v);
      return result;
    }

/*******************************************************************/ 
 
 
  public double EvalFonct(double x,double y,double z) 
    throws Exception {
      
      double[] v=new double[3];
      v[0]=x;v[1]=y;v[2]=z;
      ArbreDeFonction T=this.getArbreDeFonction();
      double result=EvalArbre(T,v);
      return result;
    }

/*******************************************************************/ 
       
}
